#include <stdio.h>
#include "mtypes.h"
#include "sort3.h"

uint32 *ContextsBf, *IdxsBf, *NewContextsBf, CxWidth, Length1;
uint32 Counters[65536];

#define MarkIndex ((uint32)0x80000000)
#define ResetBit ((uint32)0x7fffffff)

#define nrm(x) (((x)<Length1)?(x):(x)-Length1)
#define CrIdx(x) ((((x)+1)!=Length)?((x)+1):0)


int fcmp0(const void *a, const void *b) {
uint32 dwa=ContextsBf[nrm((*((uint32 *)a))+CxWidth)],
       dwb=ContextsBf[nrm((*((uint32 *)b))+CxWidth)];

 if (dwa<dwb) return -1;
  else if (dwa>dwb) return 1;
 return 0;
}

uint32 BwtTrans(uint8 *ToTrans, uint32 Length) {
register uint32 i,j,k,*swp,s;
register uint32 ContextMean, NewContextMean, mark, OldMark, NewMark;
FILE *f;
 Length1=Length;
 /* sort 2-sym buckets and setup outer buffers */
 ContextsBf=(uint32 *)malloc(Length*(uint32)sizeof(uint32));
 NewContextsBf=(uint32 *)malloc(Length*(uint32)sizeof(uint32));
 IdxsBf=(uint32 *)malloc(Length*(uint32)sizeof(uint32));
 for (i=0;i<65536;i++) Counters[i]=0;

 for (i=0;i<Length-1;i++)
     Counters[(((uint16)ToTrans[i])<<8) | ((uint16)ToTrans[i+1])]++;

 Counters[(((uint16)ToTrans[Length-1])<<8) | ((uint16)ToTrans[0])]++;

 for (i=1;i<65536;i++)
     Counters[i]+=Counters[i-1];

 for (i=0;i<Length-1;i++)
     IdxsBf[--Counters[(((uint16)ToTrans[i])<<8)|((uint16)ToTrans[i+1])]]=i;
 IdxsBf[--Counters[(((uint16)ToTrans[Length-1])<<8)|((uint16)ToTrans[0])]]=Length-1;


 ContextMean=0;
 ContextsBf[IdxsBf[0]]=ContextMean;
 for (mark=0,i=1;i<Length;i++) {
     if (ToTrans[IdxsBf[i]]!=
                 ToTrans[IdxsBf[i-1]&ResetBit] ||
         ToTrans[CrIdx(IdxsBf[i])]!=
                 ToTrans[CrIdx(IdxsBf[i-1]&ResetBit)]) {
        mark^=MarkIndex;
        ContextMean++;
     }
     ContextsBf[IdxsBf[i]]=ContextMean;
     IdxsBf[i]|=mark;
 }

 CxWidth=2;
 ContextMean++;
 while (ContextMean!=Length && CxWidth<Length) {

       /* sort CxWidth*2-symbol contexts */
       j=ContextMean;
       OldMark=0; NewMark=0;
       NewContextMean=0;
       i=0;
       while (j--) {

             /* find running chain */
             s=i;
             while ((IdxsBf[s]&MarkIndex)==OldMark && s<Length) {
                   IdxsBf[s]^=OldMark;
                   s++;
             }
             /* i s */

             /* sort contexts according to OldMark, Contexts, Idxs, CxWidth */
             if (s-i>1)
                qsort3(&IdxsBf[i], s-i, sizeof(uint32), fcmp0);

             /* setup new mark */

             NewContextsBf[IdxsBf[i]]=NewContextMean;
             IdxsBf[i]|=NewMark;
             for (k=i+1; k<s; k++) {
                 if (ContextsBf[nrm(IdxsBf[k]+CxWidth)]!=
                     ContextsBf[nrm((IdxsBf[k-1]&ResetBit)+CxWidth)]) {
                    NewMark^=MarkIndex;
                    NewContextMean++;
                 }
                 NewContextsBf[IdxsBf[k]]=NewContextMean;
                 IdxsBf[k]|=NewMark;
             }
             NewMark^=MarkIndex;
             NewContextMean++;
             i=s;
             OldMark^=MarkIndex;
       }
       ContextMean=NewContextMean;
       swp=NewContextsBf; NewContextsBf=ContextsBf; ContextsBf=swp;
       CxWidth<<=1;
 }
 free(ContextsBf);free(NewContextsBf);
 f=fopen("output.dat","wb");
 for (i=0; i<Length; i++)
     fputc(ToTrans[(IdxsBf[i]&ResetBit)?(IdxsBf[i]&ResetBit)-1:Length-1],f);
 fclose(f);
 free(IdxsBf);
 return 0;
}
