#ifndef _sort3_h
#define _sort3_h

#include <stdlib.h>

#define a(x) ((void *)(((char *)base)+(x)*(long)width))
#define A(x) ((unsigned long *)(((unsigned char *)base)+(x)*(long)width))

long stack_start[32], stack_end[32];

#define swap(X,Y) { \
 p1=X;p2=Y;  \
 idx=1; \
 if (b) \
    do{}while(*p1^=*p2,*p2^=*p1,*p1++^=*p2++,idx++<b); \
 if (o) \
    if (o==1) { \
       *((unsigned char*)p1)^=*((unsigned char*)p2); \
       *((unsigned char*)p2)^=*((unsigned char*)p1); \
       *((unsigned char*)p1)^=*((unsigned char*)p2); \
    } else if (o==2) {  \
              *((unsigned short*)p1)^=*((unsigned short*)p2); \
              *((unsigned short*)p2)^=*((unsigned short*)p1); \
              *((unsigned short*)p1)^=*((unsigned short*)p2); \
           } else { \
              *((unsigned short*)p1)^=*((unsigned short*)p2); \
              *((unsigned short*)p2)^=*((unsigned short*)p1); \
              *((unsigned short*)p1)^=*((unsigned short*)p2); \
 \
              *(((unsigned char*)p1)+2)^=*(((unsigned char*)p2)+2); \
              *(((unsigned char*)p2)+2)^=*(((unsigned char*)p1)+2); \
              *(((unsigned char*)p1)+2)^=*(((unsigned char*)p2)+2); \
             } \
}

static void qsort3(void *base, size_t nelem, size_t width,
            int (*fcmp)(const void *, const void *)) {

 /* A stack size of 32 is enough to sort four billion items. */
register long left, right, num, j, i, middle, stack_on, idx, o, b;
register unsigned long *p1,*p2;

 stack_on = 0 ;
 stack_start[0] = 0 ;
 stack_end[0] = nelem - 1 ;

 o=width&3;b=width>>2;

 while(stack_on>=0) {

      left=stack_start[stack_on] ;
      right=stack_end[stack_on] ;
      stack_on-- ;

      /* Sort items 'left' to 'right' */
      while (left<right) {

            /* Pick the middle item based on a sample of 3 items. */
            num=right-left ;
            if (num<2) {
               if (num==1)  /* Two Items */
                  if (fcmp(a(left),a(right))>0) swap(A(left),A(right)) ;
               break ;
            }

            /* Choose 'ptr_ptr[left]' to be a median of three values */
            middle=(right+left)>>1;

            if (fcmp(a(middle),a(right))>0)
               swap(A(middle),A(right));

            if (fcmp(a(middle),a(left))>0) swap(A(left),A(middle))
             else
              if (fcmp(a(left),a(right))>0) swap(A(left),A(right)) ;

            if (num==2 ) {  /* Special Optimization on Three Items */
               swap(A(left),A(middle));
               break;
            }

            i=left+1 ;
            while (fcmp(a(left),a(i))>0) i++;

            j=right ;
            while(fcmp(a(j),a(left))>0) j--;

            while (i<j) {
                  swap(A(i),A(j));
                  i++ ;
                  while(fcmp(a(left),a(i))>0) i++;
                  j--;
                  while(fcmp(a(j),a(left))>0) j--;
            }

            swap(A(left),A(j));

            /* Both Sides are non-trivial */
            if (j-left>right-j)  {
               /* Left sort is larger, put it on the stack */
               stack_start[++stack_on]=left;
               stack_end[stack_on]=j-1;
               left=j+1;
            } else {
               /* Right sort is larger, put it on the stack */
               stack_start[++stack_on]=j+1 ;
               stack_end[stack_on]=right;
               right=j-1;
              }
      }
 }
}
#endif
